# cdo-sdk-python
Use the documentation to explore the endpoints Security Cloud Control has to offer

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.5.0
- Package version: 1.2.519
- Generator version: 7.4.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import cdo_sdk_python
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import cdo_sdk_python
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import cdo_sdk_python
from cdo_sdk_python.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://edge.us.cdo.cisco.com/api/rest
# See configuration.py for a list of all supported configuration parameters.
configuration = cdo_sdk_python.Configuration(
    host = "https://edge.us.cdo.cisco.com/api/rest"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure Bearer authorization (JWT): bearerAuth
configuration = cdo_sdk_python.Configuration(
    access_token = os.environ["BEARER_TOKEN"]
)


# Enter a context with an instance of the API client
with cdo_sdk_python.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = cdo_sdk_python.AIAssistantApi(api_client)
    conversation_uid = 'conversation_uid_example' # str | 
    ai_question = cdo_sdk_python.AiQuestion() # AiQuestion | 

    try:
        # Ask AI Assistant (Existing Conversation)
        api_response = api_instance.ask_ai_assistant_in_existing_conversation(conversation_uid, ai_question)
        print("The response of AIAssistantApi->ask_ai_assistant_in_existing_conversation:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AIAssistantApi->ask_ai_assistant_in_existing_conversation: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://edge.us.cdo.cisco.com/api/rest*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AIAssistantApi* | [**ask_ai_assistant_in_existing_conversation**](docs/AIAssistantApi.md#ask_ai_assistant_in_existing_conversation) | **POST** /v1/ai-assistant/conversations/{conversationUid} | Ask AI Assistant (Existing Conversation)
*AIAssistantApi* | [**ask_ai_assistant_in_new_conversation**](docs/AIAssistantApi.md#ask_ai_assistant_in_new_conversation) | **POST** /v1/ai-assistant/conversations | Ask AI Assistant (New Conversation)
*AIAssistantApi* | [**get_ai_assistant_conversation_messages**](docs/AIAssistantApi.md#get_ai_assistant_conversation_messages) | **GET** /v1/ai-assistant/conversations/{conversationUid}/messages | Get Messages
*AIAssistantApi* | [**get_conversation**](docs/AIAssistantApi.md#get_conversation) | **GET** /v1/ai-assistant/conversations/{conversationUid} | Get Conversation
*AIAssistantApi* | [**get_conversations**](docs/AIAssistantApi.md#get_conversations) | **GET** /v1/ai-assistant/conversations | Get Conversations
*ASAAccessRulesApi* | [**create_access_rule**](docs/ASAAccessRulesApi.md#create_access_rule) | **POST** /v1/policies/asa/accessrules | Create Access Rule
*ASAAccessRulesApi* | [**delete_access_rule**](docs/ASAAccessRulesApi.md#delete_access_rule) | **DELETE** /v1/policies/asa/accessrules/{accessRuleUid} | Delete Access Rule
*ASAAccessRulesApi* | [**fetch_access_rule**](docs/ASAAccessRulesApi.md#fetch_access_rule) | **GET** /v1/policies/asa/accessrules/{accessRuleUid} | Get Access Rule
*ASAAccessRulesApi* | [**list_access_rules**](docs/ASAAccessRulesApi.md#list_access_rules) | **GET** /v1/policies/asa/accessrules | Get Access Rules
*ASAAccessRulesApi* | [**modify_access_rule**](docs/ASAAccessRulesApi.md#modify_access_rule) | **PATCH** /v1/policies/asa/accessrules/{accessRuleUid} | Modify ASA Access Rule
*AccessGroupsApi* | [**create_access_group**](docs/AccessGroupsApi.md#create_access_group) | **POST** /v1/policies/asa/accessgroups | Create Access Group
*AccessGroupsApi* | [**delete_access_group**](docs/AccessGroupsApi.md#delete_access_group) | **DELETE** /v1/policies/asa/accessgroups/{accessGroupUid} | Delete Access Group
*AccessGroupsApi* | [**fetch_access_group**](docs/AccessGroupsApi.md#fetch_access_group) | **GET** /v1/policies/asa/accessgroups/{accessGroupUid} | Get Access Group
*AccessGroupsApi* | [**list_access_groups**](docs/AccessGroupsApi.md#list_access_groups) | **GET** /v1/policies/asa/accessgroups | Get Access Groups
*AccessGroupsApi* | [**patch_access_group**](docs/AccessGroupsApi.md#patch_access_group) | **PATCH** /v1/policies/asa/accessgroups/{accessGroupUid} | Modify ASA Access Group
*AuditLogsApi* | [**get_audit_logs**](docs/AuditLogsApi.md#get_audit_logs) | **GET** /v1/auditlogs | Get Audit Logs
*ChangeRequestsApi* | [**create_change_request**](docs/ChangeRequestsApi.md#create_change_request) | **POST** /v1/changeRequests | Create Change Request
*ChangeRequestsApi* | [**delete_change_request**](docs/ChangeRequestsApi.md#delete_change_request) | **DELETE** /v1/changeRequests/{changeRequestUid} | Delete Change Request
*ChangeRequestsApi* | [**get_change_request**](docs/ChangeRequestsApi.md#get_change_request) | **GET** /v1/changeRequests/{changeRequestUid} | Get Change Request
*ChangeRequestsApi* | [**get_change_requests**](docs/ChangeRequestsApi.md#get_change_requests) | **GET** /v1/changeRequests | Get Change Requests
*ChangelogsApi* | [**get_changelog**](docs/ChangelogsApi.md#get_changelog) | **GET** /v1/changelogs/{changelogUid} | Get Change Log
*ChangelogsApi* | [**get_changelogs**](docs/ChangelogsApi.md#get_changelogs) | **GET** /v1/changelogs | Get Change Logs
*CloudDeliveredFMCApi* | [**proxy_fmc_request**](docs/CloudDeliveredFMCApi.md#proxy_fmc_request) | **GET** /v1/cdfmc/** | Proxy Request To Cloud-Delivered FMC
*CloudDeliveredFMCApi* | [**proxy_fmc_request1**](docs/CloudDeliveredFMCApi.md#proxy_fmc_request1) | **POST** /v1/cdfmc/** | Proxy Request To Cloud-Delivered FMC
*CloudDeliveredFMCApi* | [**proxy_fmc_request2**](docs/CloudDeliveredFMCApi.md#proxy_fmc_request2) | **PUT** /v1/cdfmc/** | Proxy Request To Cloud-Delivered FMC
*CloudDeliveredFMCApi* | [**proxy_fmc_request3**](docs/CloudDeliveredFMCApi.md#proxy_fmc_request3) | **PATCH** /v1/cdfmc/** | Proxy Request To Cloud-Delivered FMC
*CloudDeliveredFMCApi* | [**proxy_fmc_request4**](docs/CloudDeliveredFMCApi.md#proxy_fmc_request4) | **DELETE** /v1/cdfmc/** | Proxy Request To Cloud-Delivered FMC
*CommandLineInterfaceApi* | [**create_cli_macro**](docs/CommandLineInterfaceApi.md#create_cli_macro) | **POST** /v1/cli/macros | Create CLI Macro
*CommandLineInterfaceApi* | [**delete_cli_macro**](docs/CommandLineInterfaceApi.md#delete_cli_macro) | **DELETE** /v1/cli/macros/{macroUid} | Delete CLI Macro
*CommandLineInterfaceApi* | [**get_cli_macro**](docs/CommandLineInterfaceApi.md#get_cli_macro) | **GET** /v1/cli/macros/{macroUid} | Get CLI Macro
*CommandLineInterfaceApi* | [**get_cli_macros**](docs/CommandLineInterfaceApi.md#get_cli_macros) | **GET** /v1/cli/macros | Get CLI Macros
*CommandLineInterfaceApi* | [**get_cli_result**](docs/CommandLineInterfaceApi.md#get_cli_result) | **GET** /v1/cli/results/{cliResultUid} | Get CLI Result
*CommandLineInterfaceApi* | [**get_cli_results**](docs/CommandLineInterfaceApi.md#get_cli_results) | **GET** /v1/cli/results | Get CLI Results
*CommandLineInterfaceApi* | [**modify_cli_macro**](docs/CommandLineInterfaceApi.md#modify_cli_macro) | **PATCH** /v1/cli/macros/{macroUid} | Modify CLI Macro
*ConnectorsApi* | [**create_sdc**](docs/ConnectorsApi.md#create_sdc) | **POST** /v1/connectors/sdcs | Create SDC
*ConnectorsApi* | [**delete_sdc**](docs/ConnectorsApi.md#delete_sdc) | **DELETE** /v1/connectors/sdcs/{sdcUid} | Delete SDC
*ConnectorsApi* | [**get_sdc**](docs/ConnectorsApi.md#get_sdc) | **GET** /v1/connectors/sdcs/{sdcUid} | Get SDC
*ConnectorsApi* | [**get_sdcs**](docs/ConnectorsApi.md#get_sdcs) | **GET** /v1/connectors/sdcs | Get SDCs
*ConnectorsApi* | [**modify_sdc**](docs/ConnectorsApi.md#modify_sdc) | **PATCH** /v1/connectors/sdcs/{sdcUid} | Modify SDC
*InventoryApi* | [**create_duo_admin_panel**](docs/InventoryApi.md#create_duo_admin_panel) | **POST** /v1/inventory/devices/duoAdminPanels | Onboard Duo Admin Panel
*InventoryApi* | [**create_ftd_device**](docs/InventoryApi.md#create_ftd_device) | **POST** /v1/inventory/devices/ftds | Onboard FTD device
*InventoryApi* | [**delete_cd_fmc_managed_ftd_device**](docs/InventoryApi.md#delete_cd_fmc_managed_ftd_device) | **POST** /v1/inventory/devices/ftds/cdfmcManaged/{deviceUid}/delete | Delete cdFMC managed FTD device
*InventoryApi* | [**delete_cloud_service**](docs/InventoryApi.md#delete_cloud_service) | **DELETE** /v1/inventory/services/{cloudServiceUid} | Delete Cloud Service
*InventoryApi* | [**delete_device**](docs/InventoryApi.md#delete_device) | **DELETE** /v1/inventory/devices/{deviceUid} | Delete Device
*InventoryApi* | [**delete_device_manager**](docs/InventoryApi.md#delete_device_manager) | **DELETE** /v1/inventory/managers/{deviceManagerUid} | Delete Device Manager
*InventoryApi* | [**delete_template_device**](docs/InventoryApi.md#delete_template_device) | **DELETE** /v1/inventory/templates/{templateDeviceUid} | Delete Template Device
*InventoryApi* | [**deploy_asa_device_changes**](docs/InventoryApi.md#deploy_asa_device_changes) | **POST** /v1/inventory/devices/asas/{deviceUid}/deploy | Deploy ASA device changes
*InventoryApi* | [**enable_multicloud_defense**](docs/InventoryApi.md#enable_multicloud_defense) | **POST** /v1/inventory/managers/mcd | Enable Multicloud Defense
*InventoryApi* | [**execute_cli_command**](docs/InventoryApi.md#execute_cli_command) | **POST** /v1/inventory/devices/asas/cli/execute | Execute CLI Command
*InventoryApi* | [**execute_cli_macro**](docs/InventoryApi.md#execute_cli_macro) | **POST** /v1/inventory/devices/asas/cli/executeMacro | Execute CLI Macro Command
*InventoryApi* | [**finish_onboarding_ftd_device**](docs/InventoryApi.md#finish_onboarding_ftd_device) | **POST** /v1/inventory/devices/ftds/register | Register FTD device to FMC
*InventoryApi* | [**get_cloud_service**](docs/InventoryApi.md#get_cloud_service) | **GET** /v1/inventory/services/{cloudServiceUid} | Get Cloud Service
*InventoryApi* | [**get_cloud_services**](docs/InventoryApi.md#get_cloud_services) | **GET** /v1/inventory/services | Get Cloud Services
*InventoryApi* | [**get_device**](docs/InventoryApi.md#get_device) | **GET** /v1/inventory/devices/{deviceUid} | Get Device
*InventoryApi* | [**get_device_manager**](docs/InventoryApi.md#get_device_manager) | **GET** /v1/inventory/managers/{deviceManagerUid} | Get Device Manager
*InventoryApi* | [**get_device_managers**](docs/InventoryApi.md#get_device_managers) | **GET** /v1/inventory/managers | Get Device Managers
*InventoryApi* | [**get_devices**](docs/InventoryApi.md#get_devices) | **GET** /v1/inventory/devices | Get Devices
*InventoryApi* | [**get_fmc_health**](docs/InventoryApi.md#get_fmc_health) | **GET** /v1/inventory/managers/{fmcUid}/health/metrics | Get health metrics on devices managed by the FMC (cdFMC only)
*InventoryApi* | [**get_template_device**](docs/InventoryApi.md#get_template_device) | **GET** /v1/inventory/templates/{templateDeviceUid} | Get Template Device
*InventoryApi* | [**get_template_devices**](docs/InventoryApi.md#get_template_devices) | **GET** /v1/inventory/templates | Get Template Devices
*InventoryApi* | [**modify_cloud_service**](docs/InventoryApi.md#modify_cloud_service) | **PATCH** /v1/inventory/services/{cloudServiceUid} | Modify Cloud Service
*InventoryApi* | [**modify_device**](docs/InventoryApi.md#modify_device) | **PATCH** /v1/inventory/devices/{deviceUid} | Modify Device
*InventoryApi* | [**modify_device_manager**](docs/InventoryApi.md#modify_device_manager) | **PATCH** /v1/inventory/managers/{deviceManagerUid} | Modify Device Manager
*InventoryApi* | [**modify_template_device**](docs/InventoryApi.md#modify_template_device) | **PATCH** /v1/inventory/templates/{templateDeviceUid} | Modify Template Device
*InventoryApi* | [**onboard_asa_device**](docs/InventoryApi.md#onboard_asa_device) | **POST** /v1/inventory/devices/asas | Onboard ASA device
*InventoryApi* | [**onboard_ftd_device_using_ztp**](docs/InventoryApi.md#onboard_ftd_device_using_ztp) | **POST** /v1/inventory/devices/ftds/ztp | Onboard FTD device using Zero-Touch Provisioning
*InventoryApi* | [**onboard_ios_device**](docs/InventoryApi.md#onboard_ios_device) | **POST** /v1/inventory/devices/ios | Onboard IOS Device
*InventoryApi* | [**provision_cd_fmc**](docs/InventoryApi.md#provision_cd_fmc) | **POST** /v1/inventory/managers/cdfmc | Provision cdFMC
*InventoryApi* | [**read_asa_device_configuration**](docs/InventoryApi.md#read_asa_device_configuration) | **POST** /v1/inventory/devices/asas/{deviceUid}/read | Read ASA device configuration
*InventoryApi* | [**reconnect_asa_device**](docs/InventoryApi.md#reconnect_asa_device) | **POST** /v1/inventory/devices/asas/{deviceUid}/reconnect | Reconnect ASA device
*MSPApi* | [**add_active_directory_groups_to_tenant_in_msp_portal**](docs/MSPApi.md#add_active_directory_groups_to_tenant_in_msp_portal) | **POST** /v1/msp/tenants/{tenantUid}/users/groups | Add Active Directory Groups to Security Cloud Control tenant in MSP Portal
*MSPApi* | [**add_msp_tenant**](docs/MSPApi.md#add_msp_tenant) | **POST** /v1/msp/tenants | Add Tenant to MSP Portal (API token)
*MSPApi* | [**add_tenant_to_msp_portal**](docs/MSPApi.md#add_tenant_to_msp_portal) | **POST** /v1/msp/tenants/{tenantUid} | Add tenant to MSP Portal
*MSPApi* | [**add_users_to_tenant_in_msp_portal**](docs/MSPApi.md#add_users_to_tenant_in_msp_portal) | **POST** /v1/msp/tenants/{tenantUid}/users | Add users to Security Cloud Control tenant in MSP Portal
*MSPApi* | [**create_tenant**](docs/MSPApi.md#create_tenant) | **POST** /v1/msp/tenants/create | Create Security Cloud Control Tenant
*MSPApi* | [**delete_user_groups_from_tenant_in_msp_portal**](docs/MSPApi.md#delete_user_groups_from_tenant_in_msp_portal) | **POST** /v1/msp/tenants/{tenantUid}/users/groups/delete | Remove user groups from Security Cloud Control tenant in MSP Portal
*MSPApi* | [**delete_users_from_tenant_in_msp_portal**](docs/MSPApi.md#delete_users_from_tenant_in_msp_portal) | **POST** /v1/msp/tenants/{tenantUid}/users/delete | Remove users from Security Cloud Control tenant in MSP Portal
*MSPApi* | [**enable_multicloud_defense_for_tenant_in_msp_portal**](docs/MSPApi.md#enable_multicloud_defense_for_tenant_in_msp_portal) | **POST** /v1/msp/tenants/{tenantUid}/mcd | Enable Multicloud Defense for Security Cloud Control tenant in MSP Portal
*MSPApi* | [**generate_api_token_for_user_in_tenant**](docs/MSPApi.md#generate_api_token_for_user_in_tenant) | **POST** /v1/msp/tenants/{tenantUid}/users/{apiUserUid}/token | Generate token for API-only user on tenant managed by MSP portal
*MSPApi* | [**get_msp_managed_tenant**](docs/MSPApi.md#get_msp_managed_tenant) | **GET** /v1/msp/tenants/{tenantUid} | Get Security Cloud Control tenant managed by MSP Portal
*MSPApi* | [**get_msp_managed_tenants**](docs/MSPApi.md#get_msp_managed_tenants) | **GET** /v1/msp/tenants | Get Security Cloud Control tenants managed by MSP Portal
*MSPApi* | [**get_user_groups_in_tenant_in_msp_portal**](docs/MSPApi.md#get_user_groups_in_tenant_in_msp_portal) | **GET** /v1/msp/tenants/{tenantUid}/users/groups | Get user groups associated with tenant in MSP portal
*MSPApi* | [**get_users_in_tenant_in_msp_portal**](docs/MSPApi.md#get_users_in_tenant_in_msp_portal) | **GET** /v1/msp/tenants/{tenantUid}/users | Get Users associated with tenant in MSP portal
*MSPApi* | [**provision_cd_fmc_for_tenant_in_msp_portal**](docs/MSPApi.md#provision_cd_fmc_for_tenant_in_msp_portal) | **POST** /v1/msp/tenants/{tenantUid}/cdfmc | Provision cdFMC for Security Cloud Control tenant in MSP Portal
*MSPApi* | [**remove_tenant_from_msp_portal**](docs/MSPApi.md#remove_tenant_from_msp_portal) | **DELETE** /v1/msp/tenants/{tenantUid} | Remove tenant from MSP Portal
*MetaApi* | [**get_jwks**](docs/MetaApi.md#get_jwks) | **GET** /.well-known/jwks.json | Fetch JSON Web Key Set
*MetaApi* | [**get_meta**](docs/MetaApi.md#get_meta) | **GET** /v1/meta | Get Meta information
*MetaApi* | [**get_regions**](docs/MetaApi.md#get_regions) | **GET** /v1/regions | Get Security Cloud Control Regions
*ObjectManagementApi* | [**create_object**](docs/ObjectManagementApi.md#create_object) | **POST** /v1/objects | Create Object
*ObjectManagementApi* | [**create_targets**](docs/ObjectManagementApi.md#create_targets) | **POST** /v1/objects/{uid}/targets | Create Targets
*ObjectManagementApi* | [**delete_object**](docs/ObjectManagementApi.md#delete_object) | **DELETE** /v1/objects/{uid} | Delete Object
*ObjectManagementApi* | [**delete_targets**](docs/ObjectManagementApi.md#delete_targets) | **DELETE** /v1/objects/{uid}/targets | Delete Targets
*ObjectManagementApi* | [**get_duplicate_objects**](docs/ObjectManagementApi.md#get_duplicate_objects) | **GET** /v1/objects/{uid}/duplicates | Get Duplicate Objects
*ObjectManagementApi* | [**get_issues_count**](docs/ObjectManagementApi.md#get_issues_count) | **GET** /v1/objects/issues-count | Get Issues Count
*ObjectManagementApi* | [**get_object**](docs/ObjectManagementApi.md#get_object) | **GET** /v1/objects/{uid} | Get Object
*ObjectManagementApi* | [**get_object_usages**](docs/ObjectManagementApi.md#get_object_usages) | **GET** /v1/objects/{uid}/usage | Get Object Usages
*ObjectManagementApi* | [**get_objects**](docs/ObjectManagementApi.md#get_objects) | **GET** /v1/objects | Get Objects
*ObjectManagementApi* | [**get_override_object**](docs/ObjectManagementApi.md#get_override_object) | **GET** /v1/objects/overrides/{uid} | Get Override Object With Values For Specific Target
*ObjectManagementApi* | [**modify_object**](docs/ObjectManagementApi.md#modify_object) | **PATCH** /v1/objects/{uid} | Modify Object
*RemoteAccessMonitoringApi* | [**get_mfa_event**](docs/RemoteAccessMonitoringApi.md#get_mfa_event) | **GET** /v1/mfaevents/{mfaEventUid} | Get MFA Event
*RemoteAccessMonitoringApi* | [**get_mfa_events**](docs/RemoteAccessMonitoringApi.md#get_mfa_events) | **GET** /v1/mfaevents | Get MFA Events
*RemoteAccessMonitoringApi* | [**get_ra_vpn_session**](docs/RemoteAccessMonitoringApi.md#get_ra_vpn_session) | **GET** /v1/vpnsessions/{raVpnSessionUid} | Get RA VPN Session
*RemoteAccessMonitoringApi* | [**get_ra_vpn_sessions**](docs/RemoteAccessMonitoringApi.md#get_ra_vpn_sessions) | **GET** /v1/vpnsessions | Get RA VPN Sessions
*RemoteAccessMonitoringApi* | [**refresh_ra_vpn_sessions_by_device**](docs/RemoteAccessMonitoringApi.md#refresh_ra_vpn_sessions_by_device) | **POST** /v1/vpnsessions/refresh | Refresh RA VPN Sessions
*RemoteAccessMonitoringApi* | [**terminate_ra_vpn_sessions_by_device**](docs/RemoteAccessMonitoringApi.md#terminate_ra_vpn_sessions_by_device) | **POST** /v1/vpnsessions/{deviceUid}/terminate | Terminate RA VPN Sessions
*RemoteAccessMonitoringApi* | [**terminate_ra_vpn_sessions_by_device_and_user_name**](docs/RemoteAccessMonitoringApi.md#terminate_ra_vpn_sessions_by_device_and_user_name) | **POST** /v1/vpnsessions/{deviceUid}/terminate/{userName} | Terminate User&#39;s RA VPN Sessions
*SearchApi* | [**initiate_full_indexing**](docs/SearchApi.md#initiate_full_indexing) | **POST** /v1/search/index | Rebuild search index
*SearchApi* | [**search**](docs/SearchApi.md#search) | **GET** /v1/search | Search
*TenantManagementApi* | [**get_feature_flags**](docs/TenantManagementApi.md#get_feature_flags) | **GET** /v1/features | Get Feature Flags
*TenantManagementApi* | [**get_tenant**](docs/TenantManagementApi.md#get_tenant) | **GET** /v1/tenants/{tenantUid} | Get Tenant
*TenantManagementApi* | [**get_tenant_settings**](docs/TenantManagementApi.md#get_tenant_settings) | **GET** /v1/settings/tenant | Get Tenant Settings
*TenantManagementApi* | [**get_tenants**](docs/TenantManagementApi.md#get_tenants) | **GET** /v1/tenants | Get Tenants
*TenantManagementApi* | [**modify_tenant_settings**](docs/TenantManagementApi.md#modify_tenant_settings) | **PATCH** /v1/settings/tenant | Modify Tenant Settings
*TransactionsApi* | [**get_transaction**](docs/TransactionsApi.md#get_transaction) | **GET** /v1/transactions/{transactionUid} | Get Transaction
*UsersApi* | [**create_active_directory_group**](docs/UsersApi.md#create_active_directory_group) | **POST** /v1/users/groups | Create Active Directory Group in Security Cloud Control Tenant
*UsersApi* | [**create_user**](docs/UsersApi.md#create_user) | **POST** /v1/users | Create User in Security Cloud Control Tenant
*UsersApi* | [**delete_active_directory_group**](docs/UsersApi.md#delete_active_directory_group) | **DELETE** /v1/users/groups/{groupUid} | Remove Active Directory Group from Security Cloud Control Tenant
*UsersApi* | [**delete_user**](docs/UsersApi.md#delete_user) | **DELETE** /v1/users/{userUid} | Remove User from Security Cloud Control Tenant
*UsersApi* | [**generate_api_token**](docs/UsersApi.md#generate_api_token) | **POST** /v1/users/{apiUserUid}/apiToken/generate | Generate Token for API-only user
*UsersApi* | [**get_active_directory_group**](docs/UsersApi.md#get_active_directory_group) | **GET** /v1/users/groups/{groupUid} | Get Active Directory Group
*UsersApi* | [**get_active_directory_groups**](docs/UsersApi.md#get_active_directory_groups) | **GET** /v1/users/groups | Get Active Directory Groups
*UsersApi* | [**get_token**](docs/UsersApi.md#get_token) | **GET** /v1/token | Get Token Info
*UsersApi* | [**get_user**](docs/UsersApi.md#get_user) | **GET** /v1/users/{userUid} | Get Tenant User
*UsersApi* | [**get_users**](docs/UsersApi.md#get_users) | **GET** /v1/users | Get Tenant Users
*UsersApi* | [**modify_active_directory_group**](docs/UsersApi.md#modify_active_directory_group) | **PATCH** /v1/users/groups/{groupUid} | Modify Active Directory Group
*UsersApi* | [**revoke_api_token**](docs/UsersApi.md#revoke_api_token) | **POST** /v1/users/{apiUserUid}/apiToken/revoke | Revoke API-only User&#39;s Token
*UsersApi* | [**revoke_token**](docs/UsersApi.md#revoke_token) | **POST** /v1/token/revoke | Revoke Token
*SwaggerRedirectControllerApi* | [**redirect_with_using_redirect_view**](docs/SwaggerRedirectControllerApi.md#redirect_with_using_redirect_view) | **GET** /swagger-ui/** | 


## Documentation For Models

 - [AccessGroup](docs/AccessGroup.md)
 - [AccessGroupCreateInput](docs/AccessGroupCreateInput.md)
 - [AccessGroupPage](docs/AccessGroupPage.md)
 - [AccessGroupUpdateInput](docs/AccessGroupUpdateInput.md)
 - [AccessRule](docs/AccessRule.md)
 - [AccessRuleCreateInput](docs/AccessRuleCreateInput.md)
 - [AccessRuleDetailsContent](docs/AccessRuleDetailsContent.md)
 - [AccessRulePage](docs/AccessRulePage.md)
 - [AccessRuleUpdateInput](docs/AccessRuleUpdateInput.md)
 - [ActiveDirectoryGroup](docs/ActiveDirectoryGroup.md)
 - [ActiveDirectoryGroupCreateOrUpdateInput](docs/ActiveDirectoryGroupCreateOrUpdateInput.md)
 - [ActiveDirectoryGroupPage](docs/ActiveDirectoryGroupPage.md)
 - [AiAssistantConversationPage](docs/AiAssistantConversationPage.md)
 - [AiConversation](docs/AiConversation.md)
 - [AiMessage](docs/AiMessage.md)
 - [AiQuestion](docs/AiQuestion.md)
 - [ApiTokenInfo](docs/ApiTokenInfo.md)
 - [ApplicationContext](docs/ApplicationContext.md)
 - [ApplicationContextClassLoader](docs/ApplicationContextClassLoader.md)
 - [ApplicationContextClassLoaderParent](docs/ApplicationContextClassLoaderParent.md)
 - [ApplicationContextClassLoaderParentUnnamedModule](docs/ApplicationContextClassLoaderParentUnnamedModule.md)
 - [ApplicationContextClassLoaderParentUnnamedModuleClassLoader](docs/ApplicationContextClassLoaderParentUnnamedModuleClassLoader.md)
 - [ApplicationContextClassLoaderParentUnnamedModuleClassLoaderDefinedPackagesInner](docs/ApplicationContextClassLoaderParentUnnamedModuleClassLoaderDefinedPackagesInner.md)
 - [ApplicationContextClassLoaderParentUnnamedModuleDescriptor](docs/ApplicationContextClassLoaderParentUnnamedModuleDescriptor.md)
 - [AsaCreateOrUpdateInput](docs/AsaCreateOrUpdateInput.md)
 - [AsaFailoverMate](docs/AsaFailoverMate.md)
 - [AsaFailoverMode](docs/AsaFailoverMode.md)
 - [AuditLog](docs/AuditLog.md)
 - [AuditLogPage](docs/AuditLogPage.md)
 - [AuthenticationError](docs/AuthenticationError.md)
 - [Browser](docs/Browser.md)
 - [CdFmcInfo](docs/CdFmcInfo.md)
 - [CdFmcObject](docs/CdFmcObject.md)
 - [CdFmcResult](docs/CdFmcResult.md)
 - [CdoCliMacro](docs/CdoCliMacro.md)
 - [CdoCliMacroPage](docs/CdoCliMacroPage.md)
 - [CdoCliResult](docs/CdoCliResult.md)
 - [CdoCliResultPage](docs/CdoCliResultPage.md)
 - [CdoRegion](docs/CdoRegion.md)
 - [CdoRegionList](docs/CdoRegionList.md)
 - [CdoTokenInfo](docs/CdoTokenInfo.md)
 - [CdoTransaction](docs/CdoTransaction.md)
 - [ChangeRequest](docs/ChangeRequest.md)
 - [ChangeRequestCreateInput](docs/ChangeRequestCreateInput.md)
 - [ChangeRequestPage](docs/ChangeRequestPage.md)
 - [Changelog](docs/Changelog.md)
 - [ChangelogPage](docs/ChangelogPage.md)
 - [ChassisStatsHealthMetrics](docs/ChassisStatsHealthMetrics.md)
 - [CliCommandInput](docs/CliCommandInput.md)
 - [CliMacroCreateInput](docs/CliMacroCreateInput.md)
 - [CliMacroExecuteInput](docs/CliMacroExecuteInput.md)
 - [CliMacroPatchInput](docs/CliMacroPatchInput.md)
 - [ClientDevice](docs/ClientDevice.md)
 - [ClusterNode](docs/ClusterNode.md)
 - [CommonApiError](docs/CommonApiError.md)
 - [ConfigState](docs/ConfigState.md)
 - [ConflictDetectionInterval](docs/ConflictDetectionInterval.md)
 - [ConflictDetectionState](docs/ConflictDetectionState.md)
 - [ConnectivityState](docs/ConnectivityState.md)
 - [ConnectorType](docs/ConnectorType.md)
 - [CpuHealthMetrics](docs/CpuHealthMetrics.md)
 - [CreateRequest](docs/CreateRequest.md)
 - [Device](docs/Device.md)
 - [DevicePage](docs/DevicePage.md)
 - [DevicePatchInput](docs/DevicePatchInput.md)
 - [DeviceRole](docs/DeviceRole.md)
 - [DiskHealthMetrics](docs/DiskHealthMetrics.md)
 - [DuoAdminPanelCreateOrUpdateInput](docs/DuoAdminPanelCreateOrUpdateInput.md)
 - [DuplicateGroupDto](docs/DuplicateGroupDto.md)
 - [Entity](docs/Entity.md)
 - [EntityType](docs/EntityType.md)
 - [Environment](docs/Environment.md)
 - [Event](docs/Event.md)
 - [FmcHealthMetrics](docs/FmcHealthMetrics.md)
 - [FtdClusterInfo](docs/FtdClusterInfo.md)
 - [FtdCreateOrUpdateInput](docs/FtdCreateOrUpdateInput.md)
 - [FtdHaInfo](docs/FtdHaInfo.md)
 - [FtdRegistrationInput](docs/FtdRegistrationInput.md)
 - [GlobalSearchResult](docs/GlobalSearchResult.md)
 - [GroupContent](docs/GroupContent.md)
 - [HaHealthMetrics](docs/HaHealthMetrics.md)
 - [HaNode](docs/HaNode.md)
 - [Icmp4Value](docs/Icmp4Value.md)
 - [Icmp6Value](docs/Icmp6Value.md)
 - [InterfaceHealthMetrics](docs/InterfaceHealthMetrics.md)
 - [Inventory](docs/Inventory.md)
 - [IosCreateOrUpdateInput](docs/IosCreateOrUpdateInput.md)
 - [IssuesCount](docs/IssuesCount.md)
 - [IssuesDto](docs/IssuesDto.md)
 - [JsonWebKey](docs/JsonWebKey.md)
 - [JwkSet](docs/JwkSet.md)
 - [Labels](docs/Labels.md)
 - [ListObjectResponse](docs/ListObjectResponse.md)
 - [Location](docs/Location.md)
 - [LogSettings](docs/LogSettings.md)
 - [MemoryHealthMetrics](docs/MemoryHealthMetrics.md)
 - [MerakiDeploymentMode](docs/MerakiDeploymentMode.md)
 - [Meta](docs/Meta.md)
 - [MfaEvent](docs/MfaEvent.md)
 - [MfaEventPage](docs/MfaEventPage.md)
 - [MspAddTenantInput](docs/MspAddTenantInput.md)
 - [MspAddUsersToTenantInput](docs/MspAddUsersToTenantInput.md)
 - [MspCreateTenantInput](docs/MspCreateTenantInput.md)
 - [MspDeleteUserGroupsFromTenantInput](docs/MspDeleteUserGroupsFromTenantInput.md)
 - [MspDeleteUsersFromTenantInput](docs/MspDeleteUsersFromTenantInput.md)
 - [MspManagedTenant](docs/MspManagedTenant.md)
 - [MspManagedTenantPage](docs/MspManagedTenantPage.md)
 - [Network](docs/Network.md)
 - [NetworkObjectContent](docs/NetworkObjectContent.md)
 - [OS](docs/OS.md)
 - [ObjectContent](docs/ObjectContent.md)
 - [ObjectResponse](docs/ObjectResponse.md)
 - [OnPremFmcInfo](docs/OnPremFmcInfo.md)
 - [Override](docs/Override.md)
 - [Policy](docs/Policy.md)
 - [PortsValue](docs/PortsValue.md)
 - [ProtocolValueContent](docs/ProtocolValueContent.md)
 - [PublicKey](docs/PublicKey.md)
 - [RaVpnDeviceInput](docs/RaVpnDeviceInput.md)
 - [RaVpnSession](docs/RaVpnSession.md)
 - [RaVpnSessionPage](docs/RaVpnSessionPage.md)
 - [RedirectView](docs/RedirectView.md)
 - [RedirectViewServletContext](docs/RedirectViewServletContext.md)
 - [RedirectViewServletContextFilterRegistrationsValue](docs/RedirectViewServletContextFilterRegistrationsValue.md)
 - [RedirectViewServletContextJspConfigDescriptor](docs/RedirectViewServletContextJspConfigDescriptor.md)
 - [RedirectViewServletContextJspConfigDescriptorJspPropertyGroupsInner](docs/RedirectViewServletContextJspConfigDescriptorJspPropertyGroupsInner.md)
 - [RedirectViewServletContextJspConfigDescriptorTaglibsInner](docs/RedirectViewServletContextJspConfigDescriptorTaglibsInner.md)
 - [RedirectViewServletContextServletRegistrationsValue](docs/RedirectViewServletContextServletRegistrationsValue.md)
 - [RedirectViewServletContextSessionCookieConfig](docs/RedirectViewServletContextSessionCookieConfig.md)
 - [ReferenceInfo](docs/ReferenceInfo.md)
 - [Sdc](docs/Sdc.md)
 - [SdcCreateInput](docs/SdcCreateInput.md)
 - [SdcPage](docs/SdcPage.md)
 - [SdcPatchInput](docs/SdcPatchInput.md)
 - [ServiceObjectContent](docs/ServiceObjectContent.md)
 - [ServiceObjectValueContent](docs/ServiceObjectValueContent.md)
 - [SharedObjectValue](docs/SharedObjectValue.md)
 - [SingleContent](docs/SingleContent.md)
 - [SourceDestinationPortsValue](docs/SourceDestinationPortsValue.md)
 - [SseDeviceData](docs/SseDeviceData.md)
 - [StateMachineDetails](docs/StateMachineDetails.md)
 - [StateMachineError](docs/StateMachineError.md)
 - [Status](docs/Status.md)
 - [StatusInfo](docs/StatusInfo.md)
 - [Target](docs/Target.md)
 - [TargetsRequest](docs/TargetsRequest.md)
 - [Tenant](docs/Tenant.md)
 - [TenantPage](docs/TenantPage.md)
 - [TenantSettings](docs/TenantSettings.md)
 - [UnifiedObjectListView](docs/UnifiedObjectListView.md)
 - [UpdateRequest](docs/UpdateRequest.md)
 - [UrlObjectContent](docs/UrlObjectContent.md)
 - [User](docs/User.md)
 - [UserCreateOrUpdateInput](docs/UserCreateOrUpdateInput.md)
 - [UserInput](docs/UserInput.md)
 - [UserPage](docs/UserPage.md)
 - [UserRole](docs/UserRole.md)
 - [VpnHealthMetrics](docs/VpnHealthMetrics.md)
 - [ZtpOnboardingInput](docs/ZtpOnboardingInput.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearerAuth"></a>
### bearerAuth

- **Type**: Bearer authentication (JWT)


## Author

cdo.tac@cisco.com


